"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleStdStreams = exports.CoreContext = void 0;
const ts = __importStar(require("@terascope/utils"));
const api_1 = __importDefault(require("./api"));
/**
 * CoreContext
*/
class CoreContext {
    constructor(config, cluster, sysconfig, assignment) {
        this.arch = process.arch;
        this.platform = process.platform;
        this.sysconfig = sysconfig;
        this.cluster = cluster;
        this.name = config.name || 'terafoundation';
        this.assignment = assignment || (process.env.NODE_TYPE
            || process.env.assignment
            || process.env.ASSIGNMENT);
        // set the process.title to make it easier to find the process
        if (config.name && this.assignment) {
            const separator = this.assignment.includes('-') ? '-' : '_';
            process.title = `${config.name}${separator}${this.assignment}`;
        }
        else if (config.name) {
            process.title = config.name;
        }
        if (ts.isFunction(config.cluster_name)) {
            this.cluster_name = config.cluster_name(this.sysconfig);
        }
        if (ts.isString(config.cluster_name)) {
            this.cluster_name = config.cluster_name;
        }
        (0, api_1.default)(this);
    }
}
exports.CoreContext = CoreContext;
function handleStdStreams() {
    // See https://github.com/trentm/node-bunyan/issues/246
    function handleStdError(err) {
        if (err.code === 'EPIPE' || err.code === 'ERR_STREAM_DESTROYED') {
            // ignore
        }
        else {
            throw err;
        }
    }
    process.stdout.on('error', handleStdError);
    process.stderr.on('error', handleStdError);
}
exports.handleStdStreams = handleStdStreams;
//# sourceMappingURL=core-context.js.map